library Project1;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  BTMemoryModule,
  Windows,
  dialogs;

{$R project1.res}
{$R demodll.res}
type
  TTestCallstd = procedure(f_Text: PChar); stdcall;
  TTestCallcdel = procedure(f_Text: PChar); cdecl;

var
    m_TestCallstd: TTestCallstd;
    m_TestCallcdel: TTestCallcdel;
    mp_DllData: Pointer;
    m_DllDataSize: Integer;
    mp_MemoryModule: PBTMemoryModule;

procedure loaddll;
var
  MemoryStream: TMemoryStream;
  rStream:TResourceStream;
begin
  MemoryStream := TMemoryStream.Create;
  rStream := TResourceStream.Create(hinstance, 'demodll', RT_RCDATA);
  MemoryStream.CopyFrom(rStream, 0);
  MemoryStream.Position := 0;
  m_DllDataSize := MemoryStream.Size;
  mp_DllData := GetMemory(m_DllDataSize);
  MemoryStream.Read(mp_DllData^, m_DllDataSize);
  MemoryStream.Free;
end;

procedure unloaddll;
begin
  FreeMemory(mp_DllData);
end;

procedure testdll(s:pansichar);
begin
  mp_MemoryModule := BTMemoryLoadLibary(mp_DllData, m_DllDataSize);
  try
    if mp_MemoryModule = nil then
      Abort;
    @m_TestCallstd := BTMemoryGetProcAddress(mp_MemoryModule, 'TestCallstd');
    if @m_TestCallstd = nil then
      Abort;
    @m_TestCallcdel := BTMemoryGetProcAddress(mp_MemoryModule, 'TestCallcdel');
    if @m_TestCallcdel = nil then
      Abort;
    m_TestCallstd(pansichar('This is a Dll Memory call! std '+s));
    m_TestCallcdel(pansichar('This is a Dll Memory call! cdecl '+s));
  except
    Showmessage('An error occoured while loading the dll: ' +
      BTMemoryGetLastError);
  end;
  if mp_MemoryModule <> nil then
    BTMemoryFreeLibrary(mp_MemoryModule);
end;

exports testdll,
        loaddll,
        unloaddll;

begin
end.
